/*
**************************************************************************************************************
*                                                 NXP USB Host Stack
*
*                                     (c) Copyright 2008, NXP SemiConductors
*                                     (c) Copyright 2008, OnChip  Technologies LLC
*                                                 All Rights Reserved
*
*                                                  www.nxp.com
*                                               www.onchiptech.com
*
* File           : usbhost_main.c
* Programmer(s)  : Ravikanth.P
* Version        :
*
**************************************************************************************************************
*/

/*
**************************************************************************************************************
*                                       INCLUDE HEADER FILES
**************************************************************************************************************
*/
#include  "usbhost_main.h"
#include <cr_section_macros.h>
#include <NXP/crp.h>
__CRP const unsigned int CRP_WORD = CRP_NO_CRP ;
//=================================================================
#include "LPC176x.h"
//Kennung cmsis
#ifndef PINSEL0
//LPC176x.h-V1.09 fehlt
#endif
#ifndef LPC_PINCON->PINSEL0
//LPC17xx.h-V1.09 fehlt
#endif
//globale variablen
volatile uint16_t touch_cmd2=5,touch_cmd2_alt=5;
volatile uint8_t mp3_dir=0;
/*__DATA(RAM2) */unsigned char buffer[2048];//64x32   /* file copy buffer */
//unsigned char buffer[13000];//64x32   /* file copy buffer */

volatile uint16_t bool_menu=0;
#define mn_mp3 1
#define mn_sdhc 2
#define mn_usbstick 4
#define mn_programmstart 8

//includes
#include "glcd/glcd.h"
#include "glcd/kklcdxx.h"
#include "start/start.h"
#include "fat/startfat.h"
#include "touch/touchall.h"
#include "player/vs_test.h"

/*
**************************************************************************************************************
*                                          MAIN FUNCTION
*
* Description: This function is the main function where the execution begins
*
* Arguments  : None
*
* Returns    : 
*
**************************************************************************************************************
*/

int main()
{
    USB_INT32S  rc;
	USB_INT32U  numBlks, blkSize;
	USB_INT08U  inquiryResult[INQUIRY_LENGTH];


	FATFS fs[2];         /* Work area (file system object) for logical drives */
	FIL fsrc, fdst;      /* file objects */
	FRESULT res;         /* FatFs function common result code */
	BYTE  b, drv = 0,zlzl=1;
	UINT s1, s2, cnt, blen = sizeof Buff;
	//UINT br;//, bw;         /* File read/write count */
	//char *ptr;//, *ptr2;
	//long p1=0, p2;//, p3;

	uint32_t ix;//,iy;
	u16 posx=0,min_alt=MIN,sensor;




// Code Red - if CMSIS 1.3 setup is being used, then SystemInit() routine
// will be called by startup code rather than in application's main()
#ifndef __USE_CMSIS
	SystemInit();                               /* initialize clocks */
#endif

 init_all();
 //überprüfung f_cpu für _delay_ms:
 //cpuspeed();wait; wait; wait; wait; wait; wait; wait; wait; wait;
LCD_Clear(Red);
init_touch();

sbi(bool_menu,mn_mp3);
sbi(bool_menu,mn_sdhc);
cbi(bool_menu,mn_usbstick);

/*PLL1CFG|=1<<0;
PLL1CFG|=1<<1;
PLL1CFG&=~(1<<2);
PLL1CFG&=~(1<<3);
PLL1CFG&=~(1<<4);
PLL1CFG|=1<<5;
PLL1CFG&=~(1<<6);
*/

while(1){//menu-endlos-schleife

while( gbi(bool_menu,mn_mp3)==1 && gbi(bool_menu,mn_sdhc)==1 ){
if(gbi(bool_menu,mn_sdhc)==1){//mp3
ix=f_mount(0, &fs[0]);
init_vs();
vs_hellotest();
mp3_anz_verzeichnisse=vs_MP3_subdirselect(99);
vs_MP3_init();
vs_MP3_subdirshow();

while( gbi(bool_menu,mn_mp3)==1&& gbi(bool_menu,mn_sdhc)==1 ){
if(mp3_neustart==1)GPREG0&=~0x00000080;
mp3_neustart=0;
//if((GPREG0 & 0x7f)>mp3_anz_verzeichnisse){GPREG0&=~(0x0000007f);}
//ix=((GPREG0 & 0x00ff0000)>>16);

lgi(20,1,GPREG0 & 0x0000007f);lw("/");//dir
li((GPREG0 & 0x0000ff00)>>8);lw("/");//track
li((GPREG0 & 0x00ff0000)>>16);//buffer


vs_MP3_subdirselect(GPREG0 & 0x7f);
ix =vs_MP3_filesinsubdirshow();

vs_MP3_subdirselect(GPREG0 & 0x7f);

vs_MP3_playfilenr((GPREG0 & 0x0000ff00)>>8,(GPREG0 & 0x00ff0000)>>16);
}//end mp3_status
}//mn_sdhc
}//mn_mp3

//=====================================================


if(gbi(bool_menu,mn_mp3)==1 && gbi(bool_menu,mn_usbstick)==1 ){//mp3

//=================================================
    UART_Init(115200);         /* Initialize the serial port to view the log messages                       */
    Host_Init();               /* Initialize the lpc17xx host controller                                    */
    rc = Host_EnumDev();       /* Enumerate the device connected                                            */
    if (rc == OK) {
		/* Initialize the mass storage and scsi interfaces */
        rc = MS_Init( &blkSize, &numBlks, inquiryResult );
        if (rc == OK) {
            rc = FAT_Init();   /* Initialize the FAT16 file system                                          */
            if (rc == OK) {
            	//usbstick ok
               // Main_Copy();   /* Call the application                                                      */
lgw(20,1, "USB-Stick ok ")
            } else {
            	break;
//				while ( 1 );
 //               return (0);
            }
        } else {
        break;
//			while ( 1 );
//            return (0);
        }
    } else {							
     break;
//		while ( 1 );
//        return (0);
    }

//    while(1);

}//if(gbi(bool_menu,mn_usbstick)==1){//mp3



//Ende MP3
while( gbi(bool_menu,mn_mp3)==0){
mp3_neustart=0;

	//.......................................
if (TP_INT_IN==0 ){touch_exe();}//touchbefehl prüfen

if(ir_pin){
		//ir_menu();
		}
	//--------------- Sensoren --------------



//++++++++++++ min ++++++++++++++++++
	if(sec_alt!=SEC){sec_alt=SEC;
	lcd_rtc_sec();
//++++++++++++ min ++++++++++++++++++
	if(min_alt!=MIN){min_alt=MIN;
	sensor=	ds1820_auslesen_to_global_TR();
	lgi(2,1,sensor16);lw(" "); li(sensor17);

	posx=(HOUR*10)+(MIN/6)-20;
//	glcd_pix(posx+MIN%6,200-(sensor-200),Blue);
	if(MIN%6==0){
		glcd_pix(posx,200-(sensor16-200),Yellow);
		glcd_pix(posx,200-(sensor17-200),Blue);
	}


	/*ix=(LPC_GPIO0->FIOPIN & (1<<10));
	lgi(5,10,ix);
	lgi(6,10,pinVAL(0,10));
	lgi(7,10,LPC_GPIO2->FIOPIN & (1<<12));*/
			  lcd_rtc();
	lgi(2,10,pinVAL(0,19));

	if(HOUR==3 || gbi(bool_menu, mn_programmstart)==0)
		auto_sommerzeit();
	}//min
	}//sec
	sbi(bool_menu, mn_programmstart);


}//mn_mp3=0
}//Haupt-Endlosschleife
return(0);
}//end main

/*
**************************************************************************************************************
*                                      READ DATA FROM DISK
*
* Description: This function is used by the user to read data from the disk
*
* Arguments  : None
*
* Returns    : None
*
**************************************************************************************************************
*/

void  Main_Read (void)
{
    USB_INT32S  fdr;
    USB_INT32U  bytes_read;
    

    fdr = FILE_Open(FILENAME_R, RDONLY);
    if (fdr > 0) {
        PRINT_Log("Reading from %s...\n", FILENAME_R);
        do {
            bytes_read = FILE_Read(fdr, UserBuffer, MAX_BUFFER_SIZE);
        } while (bytes_read);

        FILE_Close(fdr);
        PRINT_Log("Read Complete\n");
    } else {
        PRINT_Log("Could not open file %s\n", FILENAME_R);
        return;
    }
}

/*
**************************************************************************************************************
*                                      WRITE DATA TO DISK
*
* Description: This function is used by the user to write data to disk
*
* Arguments  : None
*
* Returns    : None
*
**************************************************************************************************************
*/

void  Main_Write (void)
{
    USB_INT32S  fdw;
    USB_INT32S  fdr;
    USB_INT32U  tot_bytes_written;
    USB_INT32U  bytes_written;


    fdr = FILE_Open(FILENAME_R, RDONLY);
    if (fdr > 0) {
        FILE_Read(fdr, UserBuffer, MAX_BUFFER_SIZE);
        fdw = FILE_Open(FILENAME_W, RDWR);
        if (fdw > 0) {
            tot_bytes_written = 0;
            PRINT_Log("Writing to %s...\n", FILENAME_W);
            do {
                bytes_written = FILE_Write(fdw, UserBuffer, MAX_BUFFER_SIZE);
                tot_bytes_written += bytes_written;
            } while (tot_bytes_written < WRITE_SIZE);
            FILE_Close(fdw);
            PRINT_Log("Write completed\n");
        } else {
            PRINT_Log("Could not open file %s\n", FILENAME_W);
            return;
        }
        FILE_Close(fdr);
    } else {
        PRINT_Log("Could not open file %s\n", FILENAME_R);
        return;
    }
}

/*
**************************************************************************************************************
*                                    COPYING A FILE
*
* Description: This function is used by the user to copy a file
*
* Arguments  : None
*
* Returns    : None
*
**************************************************************************************************************
*/

void  Main_Copy (void)
{
    USB_INT32S  fdr;
    USB_INT32S  fdw;
    USB_INT32U  bytes_read;


    fdr = FILE_Open(FILENAME_R, RDONLY);
    if (fdr > 0) {
        fdw = FILE_Open(FILENAME_W, RDWR);
        if (fdw > 0) {
            PRINT_Log("Copying from %s to %s...\n", FILENAME_R, FILENAME_W);
            do {
                bytes_read = FILE_Read(fdr, UserBuffer, MAX_BUFFER_SIZE);
                FILE_Write(fdw, UserBuffer, bytes_read);
            } while (bytes_read);
            FILE_Close(fdw);
        } else {
            PRINT_Log("Could not open file %s\n", FILENAME_W);
            return;
        }
        FILE_Close(fdr);
        PRINT_Log("Copy completed\n");
    } else {
        PRINT_Log("Could not open file %s\n", FILENAME_R);
        return;
    }
}
