//pinout
//20pin-Schnittstelle
//												SSP0/2
//										   CS	Mo	 Mi	  Sc

//lcd: spi cs-0.16 mo-0.18 mi-0.17 sc-0.15(ssp0/1)

//sd: ssp0/2 cs-1.21 mo-1.24 mi-1.23 sc-1.20

//vs1053: ssp0/2 cs-1.21 mo-1.24 mi-1.23 sc-1.20
//0.23 0.24 0.25 0.26 0.27 0.28 0.04 4.29 4.28 1.24 1.23 1.20 ++ -- Rst 0.05 0.11 0.10 0.00 0.01
//		   			       dreq xdcs  xds   	Mo	 Mi	  Sc  ++ -- rst

#ifndef __init_cm3board_H
#define __init_cm3board_H


#define cortex_m3 1
#define u8 uint8_t
#define u16 uint16_t
#define u32 uint32_t
#define v volatile

#define GLUE(a, b)  a##b
#define PORT(x)    GLUE(PORT, x)
#define PIN(x)    GLUE(PIN, x)
#define DDR(x)    GLUE(DDR, x)
#define sbi(var, bit) (var|=1<<bit)//set
#define cbi(var, bit) (var&=~(1<<bit))//clear
#define tbi(var, bit) (var^=1<<bit)//toggle
#define gbi(var, bit) (var>>bit&1)//get

#define FALSE   (0)
#define TRUE    (1)

//aus LPC176x.h
#define pinSET(portn,pinn) (*(volatile uint32_t*)(0x2009C018UL+(portn*0x20UL)))|=(1UL<<pinn)
#define pinCLR(portn,pinn) (*(volatile uint32_t*)(0x2009C01CUL+(portn*0x20UL)))|=(1UL<<pinn)
#define pinDIRin(portn,pinn)  (*(volatile uint32_t*)(0x2009C000UL+(portn*0x20UL)))&=~(1UL<<pinn)
#define pinDIRout(portn,pinn) (*(volatile uint32_t*)(0x2009C000UL+(portn*0x20UL)))|=(1UL<<pinn)
#define pinSEL(p,b,v)		PINSEL[(p) * 2 + (b) / 16] = (PINSEL[(p) * 2 + (b) / 16] & ~(3 << ((b) * 2 % 32))) | (v << ((b) * 2 % 32))
#define pinVAL(portn,pinn) ((*(volatile uint32_t*)(0x2009C014UL+(portn*0x20UL))& (1<<pinn))>>pinn)

#define pinMOD(p,b,v) PINMODE[(p) * 2 + (b) / 16] = (PINMODE[(p) * 2 + (b) / 16] & ~(3 << ((b) * 2 % 32))) | (v << ((b) * 2 % 32))
#define pinOPD(p,b,v) (PINMODE_OD[p] & ~(1 << (b))) | ((v) << (b))
#define mod_pullup   0
#define mod_repeater 1
#define mod_non 		2
#define mod_pulldown 3
#define opd_normal 0
#define opd_opendrain 1



//#define	__set_PCONP(p,v)	PCONP = (PCONP & ~(1 << (p))) | (1 << (p))
//#define	__set_PCLKSEL(p,v)	PCLKSEL[(p) / 16] = (PCLKSEL[(p) / 16] & ~(3 << ((p) * 2 % 32))) | (v << ((p) * 2 % 32))




#define EINT0		0x00000001
#define EINT1		0x00000002
#define EINT2		0x00000004
#define EINT3		0x00000008
#define EINT0_EDGE	0x00000001
#define EINT1_EDGE	0x00000002
#define EINT2_EDGE	0x00000004
#define EINT3_EDGE	0x00000008


#define 	led1_off		pinCLR(3,25)
#define 	led1_on 		pinSET(3,25)
#define 	led1_tog 		LPC_GPIO3->FIOPIN^=(1<<25)//{if(LPC_GPIO3->FIOPIN && (1<<25))led1_off;else led1_on;}
#define 	led2_off		pinCLR(3,26)
#define 	led2_on 		pinSET(3,26)
#define 	led2_tog 		LPC_GPIO3->FIOPIN^=(1<<26)//{if(LPC_GPIO3->FIOPIN && (1<<26))led2_off;else led2_on;}


//#include <kk/ssp.h>
#include "start_ssp.h"
#include "rtc.h"
//#include "i2c.h"
#include "x_i2c.h"
#include "neuds1820.h"
//=========================================
volatile uint32_t zlrtc=0;
uint32_t F_DELAY=9078;//100MHZ
volatile uint32_t Timer;
volatile u8 sec_alt,touch_cmd1=0,var_menu1=0,prelltimer=0,mp3_pause=0;
volatile u32 zl_sec;
v u32 touch_x=0,touch_y=0;
v u8 mp3_neustart=0,mp3_anz_verzeichnisse=0,mp3_anz_dateien=0;
v u8 prellung=0;


#define NVIC_SYSTICK_CLK		0x00000004
#define NVIC_SYSTICK_INT		0x00000002
#define NVIC_SYSTICK_ENABLE		0x00000001
#define NVIC_ST_RELOAD (*(volatile uint32_t*)0xE000E014)
#define NVIC_ST_CTRL (*(volatile uint32_t*)0xE000E010)

//int gi_SystickCount;

// Enable interrupts
//static inline void __enable_irq()	{ asm volatile ("cpsie i"); }

// Initialize the CM3 System Tick timer, given desired rate and the current CPU rate
void vF_SysTickInit(int i_CPUClockHz, int i_SystickHz)
{
//	gi_SystickCount = 0;
	/* Configure SysTick to interrupt at the requested rate. */
	NVIC_ST_RELOAD = (( i_CPUClockHz / i_SystickHz )/10) - 1UL;
	NVIC_ST_CTRL = NVIC_SYSTICK_CLK | NVIC_SYSTICK_INT | NVIC_SYSTICK_ENABLE;
}

// Interrupt handler just increments a count forever.
// Note that CM3 interrupt handlers are regular C functions - no special attributes.
/*void vF_SysTickHander(void)
{
	gi_SystickCount++;

}*/

//=========================================
void SysTick_Handler (void)
{
	static int led_timer;
	//Timer++;	/* Increment performance counter */
	prelltimer++;
	if (prelltimer==50){
		prellung=0;
		led2_off;
	}

	if (++led_timer >= 100) {
		led_timer = 0;
//		lcd_rtc();
//		led2_tog;		/* Toggle LED state */
	}
#ifdef 	disk_timerproc
	disk_timerproc();	/* Disk timer process */
#endif
}
//================================================

void RTC_IRQHandler(void){
			//secval = RTC_GetTime (LPC_RTC, RTC_TIMETYPE_SECOND);
	 ILR |= ILR_RTCCIF;		/* clear interrupt flag */
//	led2_tog;
	zlrtc++;
		/* Clear pending interrupt */
		}


v u8 prelltimer;
#define max_menu1 6
void EINT0_IRQHandler (void){
 EXTINT = EINT0;		/* clear interrupt */
 //prelltimer=0;
 //while(==0){
 //prelltimer=1;
 _delay_ms(200);
 backcolor=Red;
 lgw(var_menu1+1,15," ");//=>
 var_menu1++;
 if(var_menu1>max_menu1)var_menu1=0;
 lgw(var_menu1+1,15,"|");//=>
 backcolor=White;
 led2_tog;
 //}
return;
//NVIC_SystemReset()
}

void EINT1_IRQHandler (void){
EXTINT = EINT1;		/* clear interrupt */
u8 ix;
//for (ix=0;ix<100;ix++);
led2_tog;
//mp3->select subdir
//GPREG0 & 0x000000ff =>counter subdir-mp3
//if ((GPREG0&0x7f)+2>mp3_anz_verzeichnisse){GPREG0&=~0x0000007f;}else{GPREG0++;}
GPREG0&=~0x00ffffff;//zl track+buffer resetten
//if((GPREG0 & 0x0000007f)>MP3_anzahl_unterordner)GPREG0&=~(0x0000007f);
sbi(GPREG0,7);//Neustart
//lgi(17,1,GPREG0 & 0x7f);
mp3_neustart=1;
//WDTInit();
return;
}

void EINT2_IRQHandler (void)
{
   EXTINT = EINT2;		/* clear interrupt */
led2_tog;
}

void EINT3_IRQHandler (void)
{
   EXTINT = EINT3;		/* clear interrupt */
led2_tog;
}
//==============================================================
void lcd_rtc(void){
	RTCGetTime();
	lcd_goto(1,1);
	lcd_int2( HOUR);
	lcd_write(":");
	lcd_int2( MIN);
	lcd_write(":");
	lcd_int2( SEC);
}

void lcd_rtc_sec(void){
	RTCGetTime();
	lcd_goto(1,7);
	lcd_int2( SEC);
}

//+++++++++++++++++++++++++++++++++++++++++



void cpuspeed(void){
	uint32_t i=0;
	zlrtc=0;
	led2_off;
	while(zlrtc<1);
	led2_on;
	while(zlrtc<3)i++;
	led2_off;
	F_DELAY=i/1836;
	lwi(2,1,"F_DELAY_1ms:");
	lgi(3,1,F_DELAY);
	lcd_write("xx");

	u32 kk_clksrcsel,
	kk_pll0statlow=(( PLL0STAT >> 16) & 0xFF)+1,
	kk_pll0stathighi= PLL0STAT&0x7FFF+1,
	kk_ndivider=(( CCLKCFG & 0xFF)+ 1);

		switch ( CLKSRCSEL & 0x03){
		case 3:	kk_clksrcsel=4000000;break;
		case 1:	kk_clksrcsel=12000000;break;
		case 2:	kk_clksrcsel=32000;break;
		}
#ifdef SystemFrequency
#define SystemCoreClock SystemFrequency
#endif
		lgi(4,1,SystemCoreClock);
		lgi(5,1,kk_clksrcsel);
		lgi(6,1,kk_pll0statlow);
		lgi(7,1,kk_pll0stathighi);
//		lgi(8,1,kk_ndivider);
}



void _delay_ms(long ms){
	//genau auf 100sec
	//bei 72Mhz F_CPU=6536
uint32_t i,j=F_DELAY*ms;
	for(i=0;i<j;i++);
}
/* void _delay_msx(long ms){
	//genau auf 100sec
	//bei 72Mhz F_CPU=6536
uint32_t i,j=F_DELAY*ms;
	for(i=0;i<j;i++);
}*/

void _delay_us(long us){//genau auf 100sec
uint32_t i,j=F_DELAY*us/1000;
	for(i=0;i<j;i++);
}
#define wait _delay_ms(1000)



void auto_sommerzeit(void){
//DOY=89;//Tag einstellen
//++++++++++++++ Korrektur + Umschaltung Sommer/Winterzeit ++++++++++++++++
//	ix=(84+(110-(YEAR%100)-((YEAR%100)-13)/4)%7);//test
//	ix=298+(106-(YEAR%100)-((YEAR%100)-13)/4)%7;//test
//u8 DOYx=MON*30+DAYM-1;if((YEAR%100)%4==0)DOYx++;//doy märz
//if (MON>8)DOYx+=3;//doy Okt
		if(DOY>=(84+(110-(YEAR%100)-((YEAR%100)-13)/4)%7)//letzter So im März
		&& (DOY<(298+(106-(YEAR%100)-((YEAR%100)-13)/4)%7))//letzter So im okt
			){//Sommerzeit
				if ((GPREG1>>31)==0){//EEPROM-Wert für Winterzeit
					HOUR++;
					sbi(GPREG1,31);//EEPROM-Wert für sommerzeit setzen
				}
		}else{//Winterzeit
				if ((GPREG1>>31)==1){//EEPROM-Wert für sommerzeit
					HOUR--;
					cbi(GPREG1,31);//EEPROM-Wert für sommerzeit löschen
				}
		}

	//--------------Korrektur + Umschaltung Sommer/Winterzeit ________________
}






void init_all(void){
//gpio out
	 pinDIRout(3,25);		//led1 P2.xx defined as Outputs
	 pinDIRout(3,26);		//led2 P2.xx defined as Outputs
#define irport 2
#define irpin  12
#define ir_pin (pinVAL(irport,irpin)==0)
	 pinDIRin (irport,irpin);		//ir-sensor
//	 pinMOD (irport,irpin,0);		//ir-sensor 00pullup 01repeater 02noPullup 03pulldown
//PINMODE4 |= (3<<26);
	 //	 pinOD (2,13,1);		//ir-sensor kein Pullup

	 pinDIRout(0,16);		//spi cs



//rtc
 RTCInit();
 RTCStart();
 CIIR|=IMSEC;
 NVIC_EnableIRQ(RTC_IRQn);
 ILR |= ILR_RTCCIF;		/* clear interrupt flag */
 //lcd
 LCD_Initializtion();
 LCD_Clear(0xF800);
 selectfont(2);
 //lwi(16,14,"LPC1768-Mini-DK");
 //lwi(17,14,"Development Board");
  //	  init_lcd();


	vF_SysTickInit(100000000, 10);
	__enable_irq();



//gpio input
 IO2IntEnF |= (1 << 10);
 IO2IntEnF |= (1 << 11);
 IO2IntEnF |= (1 << 12);
 //IO2IntEnF |= (1 << 13);


/* is Input */


	pinSEL(2,10,1);
	pinSEL(2,11,1);
	pinSEL(2,12,1);
//	pinSEL(2,13,1);
//PINSEL4 = 0x00100000;	// set P2.10 as EINT0 and
 //IO2IntEnF = 0x200;	    // Port2.10 is falling edge. */
 EXTMODE = EINT0_EDGE|EINT1_EDGE|EINT2_EDGE;		/* INT0 edge trigger */
 EXTPOLAR = 0;				/* INT0 is falling edge by default */

//NVIC_EnableIRQ(EINT0_IRQn);
//NVIC_SetPriority(EINT1_IRQn,1);
NVIC_EnableIRQ(EINT0_IRQn);
NVIC_EnableIRQ(EINT1_IRQn);
NVIC_EnableIRQ(EINT2_IRQn);
//NVIC_EnableIRQ(EINT3_IRQn);
//cpuspeed();
}


#endif
