//###################################################################################
//	i2c_software_master.h
//	Autor: 			Artur Funk
//###################################################################################
//#ifndef 		F_CPU
//#define 		F_CPU 8000000UL
//#endif
/////////////////////////////////////////////////////////////////////////////////////
void 			i2c_master_init(void);
void			i2c_master_clk_toggle(void);
void 		 	i2c_master_start(void);
void 			i2c_master_stop(void);

unsigned char 		i2c_try_scl(unsigned char start_trials);
unsigned char  		i2c_master_write(unsigned char b);
unsigned char 		i2c_master_read(unsigned char a);

//##########################################################################################
//			i2c_soft_master.c													 			|								 						|
//			Autor: 			Artur Funk	(a_funk80<äht>yahoo.de)							 	|
// 			Last Change 	16.11.2007			   											|
//------------------------------------------------------------------------------------------
//##########################################################################################
/*******************************************************************************************
Beschreibung:
********************************************************************************************/
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
//	Bemerkungen:
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
//
//
//
//
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
////////////////////////////////////////////////////////////////////////////////////////////
//#ifndef 	F_CPU
//#define 	F_CPU 8000000UL
//#endif
////////////////////////////////////////////////////////////////////////////////////////////
//#include <avr/io.h>
//#include <util/delay.h>
////////////////////////////////////////////////////////////////////////////////////////////
//#define I2C_DDR			0//DDRC					// Register für die I2C Kommunikation
//#define I2C_DDR_REG_BIT	0//DDC7					//
//#define I2C_PORT		0//PORTC					// I2C Port definition
#define i2c_port 		0

#define SCL				1//PC6						// Port B Pin 1
#define SDA				0//PC7						// Port B Pin 2

//#define SDA_LESE_PIN 	PINC
//#define SDA_LESE_BIT 	SDA

#define RTC_SLAVE_ADDR 0xd0
#define delay _delay_ms(1)

////////////////////////////////////////////////////////////////////////////////////////////
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void sda_low()
{
//	I2C_PORT 		&=  ~(1<<SDA);    			// internen Pull-Up aus
//	I2C_DDR 		|=   (1<<I2C_DDR_REG_BIT);  // Pin von SDA als Ausgang
	pinDIRout(i2c_port,SDA);
	pinCLR(i2c_port,SDA);
//	pinMOD(i2c_port,SDA,mod_non);
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void sda_high()
{
//	I2C_DDR 		&= ~(1<<I2C_DDR_REG_BIT);  	// Pin von SDA als Eingang
//	I2C_PORT 		|=  (1<<SDA);    			// internen Pull-Up an
pinDIRout(i2c_port,SDA);
pinSET(i2c_port,SDA);
//pinMOD(i2c_port,SDA,mod_pullup);

}
void sda_in(void){
pinDIRin(i2c_port,SDA);
//pinSET(i2c_port,SDA);
//pinMOD(i2c_port,SDA,mod_pullup);
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/////////////////////////////////////////////////////////////////////////////////////
/*Der relevante Teil des Codes:
I2C_DDR |=  (1<<SCL);
...
#define scl_l  I2C_PORT &= ~(1 << SCL)
#define scl_h I2C_PORT |=  (1 << SCL)

*/
///////

//#define scl_l		I2C_PORT &= ~(1 << SCL)	// Clock Low Output
//#define scl_h	I2C_PORT |=  (1 << SCL)	// Clock High Output
#define scl_l	pinCLR(i2c_port,SCL)	// Clock Low Output
#define scl_h	pinSET(i2c_port,SCL)	// Clock High Output

#define sda_l	sda_low()				// Daten Leitung Low
#define sda_h	sda_high()				// Data Wire High

#define	ACK				0						// Ack empfangen
#define	NACK			1						// Ack nicht empfangen

//#define S_DELAY			_delay_loop_1(1);		// ca. 2.76µs H-Time
#define S_DELAY			_delay_us(30);		// ca. 2.76µs H-Time
#define M_DELAY			_delay_us(10);
#define DELAY			_delay_ms(10);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
unsigned char i2c_try_scl(unsigned char start_trials)
{
	// 10 Mal kurz warten, wenn SCL auf LOW gehalten wird
	while((pinVAL(i2c_port,SCL)==0) && (start_trials <50))
	{
		start_trials++;
		S_DELAY;
	}
	if(pinVAL(i2c_port,SCL)==0) return 0 ; return 1;
}

void i2c_master_stop(void);
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

////////////////////////////////////////////////////////////////////////////////////////////
// I2C-Master Interface Standard Routinen
////////////////////////////////////////////////////////////////////////////////////////////
void i2c_master_init(void)
{
//	I2C_DDR |=  (1<<SCL);  						// SCL Leitung als Ausgang definieren
	pinSEL(i2c_port,SDA,0x00);
	pinDIRout(i2c_port,SDA);
	pinMOD(i2c_port,SDA,mod_non);

	pinSEL(i2c_port,SCL,0x00);
	pinDIRout(i2c_port,SCL);
	pinMOD(i2c_port,SCL,mod_non);
//		S_DELAY;
	scl_h;								// Cockleitung auf H setzen
	sda_h;								// Datenleitung auf H setzen
//		S_DELAY;								// kurz warten
	i2c_master_stop();
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void i2c_master_clk_toggle(void)
{////keine Änderung während scl high
//	i2c_try_scl(0x0A);

delay;
scl_h;

delay;
scl_l;

}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void i2c_master_start(void)
{//Änderung während scl high
	// Übergang von H->L auf SDA, wobei SCL H ist.
//	i2c_try_scl(0x0A);

	sda_h;			// SDA vorsichtshalber auf HIGH ziehen
	scl_h;			// SCL auf High
	sda_l;			// SDA auf Low ziehen
	delay;
	delay;
	scl_l;			// SCL auf low

}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void i2c_master_stop(void)
{//Änderung während scl high
	// Übergang von L->H auf SDA, wobei SCL H ist.
//	i2c_try_scl(0x0A);
//		S_DELAY;
	sda_l;			// SDA vorsichtshalber auf LOW ziehen
//		S_DELAY;			// Kurz abwarten
	scl_h;			// SCL auf High setzen
		delay;
	sda_h;			// SDA von L auf H ziehen
		delay;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
unsigned char i2c_master_write(unsigned char b)
{
	char i=0;
	for(i=0;i<8;i++)
	{
		if (b & 0x80){
			sda_h;
		}else{
			sda_l;
		}
		b=b<<1;
//		S_DELAY;
		i2c_master_clk_toggle();
	}
	// Auf ACK vom Slave Prüfen

	sda_in();

	i2c_master_clk_toggle();
	if(pinVAL(i2c_port,SDA)==1)
	{
		ic2_scan_found=1;
		return 1;
	}
	else
	{
		ic2_scan_found=0;
		return 0;
	}
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
unsigned char i2c_master_read(unsigned char a)
{
	unsigned char i,c=0b00000000;
	sda_in();

	for(i=0;i<8;i++)
	{
		c=c<<1;

		// Bitweise OR verknüpfen mit dem Eingang, MSB zuerst
		if(	pinVAL(i2c_port,SDA)) c|=1;
		i2c_master_clk_toggle();
	}

	// ACK oder NACK | ACK=0; NACK=1
	if(a==ACK)	{sda_l;} else {sda_h;}
	i2c_master_clk_toggle();
	return c;
}

// Beispiel
//...

uint16_t sweep24c_rd(uint16_t adr16){
//32k=>2048x16bit
	u16 xx=0;

//	SLAVE_ADR=0xa0;
	i2c_master_start();
	i2c_master_write(adr16);
	i2c_master_write(0x00);
	i2c_master_write(0x00);
	i2c_master_start();
	i2c_master_write(adr16+1);
	xx=i2c_master_read(ACK)<<8;
	xx|=i2c_master_read(NACK);
	i2c_master_stop();
	   return (xx);
}

unsigned char rtc_clear_time()
{
//i2c_master_init();
	// Löscht auf einfache Art die Zeit Register der RTC
	int i=0;
	i2c_master_start();
	i2c_master_write(RTC_SLAVE_ADDR);
	i2c_master_write(0x00);

	i2c_master_start();
	i2c_master_write(RTC_SLAVE_ADDR);

	for(i=0;i<8;i++)
	{
		i2c_master_write(0x00+i);
	}
	i2c_master_stop();
	return 1;
}

void swi2c1_scan(u8 startadr){
u8 ix,iz;
for(ix=startadr;ix<255;ix++){
lgh(2,1,ix);li(ic2_scan_found);
led1_tog;
ic2_scan_found=2;
i2c_master_start();
i2c_master_write(ix);
i2c_master_stop();





if(ic2_scan_found==0){
iz++;
lgh(iz,5,ix);
}
_delay_ms(200);}
}


//....
